
import Tuple;
import Line;

public class LineSegment extends Line
   {
   /*
   Define an object to hold a line segment.
   */

   //this line segment has smallest and largest x and y values
   private double xMinimum, xMaximum;
   private double yMinimum, yMaximum;

	public LineSegment()
		{
      /*
      Initialize this line segment to a point at the origin.
      */

		this(new Tuple(0, 0), new Tuple(0, 0));
		}

   public LineSegment(Tuple point1, Tuple point2)
      {
      /*
      Initialize this line segment to have the given endpoints.
      */

      super(point1, point2);

		//remember the x and y ranges of the two endpoints
      double swap;
      xMinimum = point1.getX(); xMaximum = point2.getX();
      yMinimum = point1.getY(); yMaximum = point2.getY();
      if (xMinimum > xMaximum)
         { swap = xMinimum; xMinimum = xMaximum; xMaximum = swap; }
      if (yMinimum > yMaximum)
         { swap = yMinimum; yMinimum = yMaximum; yMaximum = swap; }
      }

   public final boolean contains(Tuple point)
      {
      /*
      Report whether this line segment contains the given point.
      */

      double x = point.getX(); double y = point.getY();

      return (super.contains(point) &&
         (x >= xMinimum) && (x <= xMaximum) &&
         (y >= yMinimum) && (y <= yMaximum));
      }

   public final Tuple intersects(Line line)
      {
      /*
      Report this line segment's intersection with the given line,
      or null if they don't intersect.
      */

      //see whether they intersect as lines
      Tuple intersection = super.intersects(line);

      if (intersection == null)
         return null;

      //see whether the line intersection is on this line segment
      if (this.contains(intersection))
         return intersection;
      else
         return null;
      }
   }
