
import Tuple;
import Dimensions;

public class Rectangle
   {
   /*
   Define an object to represent a rectangle.
   */

   //this rectangle has a location and dimensions;
   //its location is the (x, y) value of its top-left corner
   private Tuple location;
   private Dimensions dimensions;

   public Rectangle(Tuple location, Dimensions dimensions)
      {
      /*
      Initialize this rectangle with the given values.
      */

      this.location = new Tuple(location.getX(), location.getY());
      this.dimensions =
         new Dimensions(dimensions.getWidth(), dimensions.getHeight());
      }

   public final double getX()
      {
      /*
      Report this rectangle's leftmost value.
      */

      return location.getX();
      }

   public final void setX(double x)
      {
      /*
      Alter this rectangle's leftmost value.
      */

      location.setX(x);
      }

   public final double getY()
      {
      /*
      Report this rectangle's topmost value.
      */

      return location.getY();
      }

   public final void setY(double y)
      {
      /*
      Alter this rectangle's topmost value.
      */

      location.setY(y);
      }

   public final double getWidth()
      {
      /*
      Report this rectangle's width.
      */

      return dimensions.getWidth();
      }

   public final double getHeight()
      {
      /*
      Report this rectangle's height.
      */

      return dimensions.getHeight();
      }
   }
