
import Dimensions;
import Troupe;
import Theater;

import java.awt.Graphics;
import java.awt.Color;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;

public class Stage extends JPanel
   {
   /*
   Define an object to represent a rectangular stage
   for a troupe of actors to paint themselves on.

   This class cannot have a zero-argument constructor;
   every stage must exist in some theater.
   */

   //this stage exists in a theater
   private final Theater theater;

   public Stage(Theater theater)
      {
      /*
      Initialize this stage to exist in the given theater.
      */

      this.theater = theater;

      Dimensions dimensions = theater.getStageDimensions();
      int width = (int) dimensions.getWidth();
      int height = (int) dimensions.getHeight();

      //dress the stage
      this.setSize(width, height);
      this.setBackground(Color.black);
      this.setBorder(new EtchedBorder(EtchedBorder.RAISED));
      this.setDoubleBuffered(true);
      this.setVisible(true);
      }

   public void paintComponent(Graphics smartTablet)
      {
      /*
      Update this stage by painting it and all the actors.
      */

      super.paintComponent(smartTablet);

      //fetch the troupe of actors from the theater
      //and tell each one to paint itself into the smartTablet
      Troupe troupe = theater.getTroupe();
      for (int index = 0; index < troupe.getSize(); index++)
         troupe.getActorAt(index).paint(smartTablet);
      }
   }
